package nl.vanhulzenonline.collections.filter
{
	import flash.utils.Dictionary;
	import mx.collections.ArrayCollection;

	public class Node implements INode
	{
		private var _synonyms:Dictionary;
		private var _token:Token;
		
		public function Node(token:Token, synonyms:Dictionary) 
		{
			_token = token;
			_synonyms = synonyms;
		}
		
		public function evaluate(data:ArrayCollection):Boolean
		{
			if (evaluateText(_token.text, data))
				return true;
			
			if (!_token.exact && _synonyms)
			{
				var texts:ArrayCollection = _synonyms[_token.text];
				for each (var text:String in texts)
				{
					if (evaluateText(text, data))
						return true;
				}
			}
			return false;
		}
		
		private function evaluateText(text:String, data:ArrayCollection):Boolean
		{
			for (var i:int; i < data.length; i++)
			{
				if (data[i].indexOf(text) > -1)
					return true;
			}
			return false;
		}
		
		public function toString():String
		{
			return _token.text;
		}
	}
}